<template>
  <v-row no-gutters>
    <v-col cols="12">
      <general-info
        class="mb-5"
        :responsible="responsible"
        :file-name="filename"
      />
      <upload-file
        @uploaded="fileUploaded"
      />
      <v-row
        class="my-9"
        no-gutters
        justify="center"
      >
        <v-btn
          color="primary"
          class="mr-10"
          :loading="loading"
          :disabled="disable"
          @click="submitLoad"
        >
          Cargar archivo de datos a sincronizar
        </v-btn>
      </v-row>
    </v-col>
  </v-row>
</template>

<script>
import { mapActions } from 'vuex';
import GeneralInfo from './GeneralInfo';
import UploadFile from './UploadFile';
import { errorOptions, successOptions } from '~/helpers/toast';

export default {
  name: 'ProgramForm',
  components: {
    GeneralInfo,
    UploadFile,
  },
  data() {
    return {
      loading: false,
      filename: '',
      file: null,
    };
  },
  computed: {
    responsible() {
      const { name, lastnames } = this.$auth.user;
      return `${name} ${lastnames}`;
    },
    disable() {
      return !this.file;
    },
  },
  methods: {
    ...mapActions({
      loadFile: 'sync/loads/loadFile',
    }),
    fileUploaded({ file, filename }) {
      this.filename = filename;
      this.file = file;
    },
    async submitLoad() {
      this.loading = true;
      try {
        await this.loadFile({ file: this.file });
        await this.$router.push('/sincronizacion/cargas');
        this.$toast.success('Se ha registrado la carga de archivo correctamente', successOptions);
      } catch (e) {
        this.$toast.error('No se pudo cargar el archivo de datos', errorOptions);
      }
      this.loading = false;
    },
  },
};
</script>
